﻿using System.IO;
using FarmerJoe.Settings;
using Styx.Helpers;

namespace FarmerJoe.ClassSettings
{
    public class HunterSettings : Styx.Helpers.Settings
    {
        public HunterSettings() : base(Path.Combine(FpswareSettings.SettingsPath, "Hunter.xml")) { }

        [Setting, DefaultValue(45)]
        public int RestHealth { get; set; }

        [Setting, DefaultValue("... always")]
        public string TravelForm { get; set; }

        [Setting, DefaultValue("... always")]
        public string CCControlledMovement { get; set; }

        [Setting, DefaultValue("... always")]
        public string CCControlledTargeting { get; set; }

        [Setting, DefaultValue("... always")]
        public string WaitForResSickness { get; set; }

        [Setting, DefaultValue("... always")]
        public string AllowLagTollerance { get; set; }

        [Setting, DefaultValue("... never")]
        public string TimeToDeathCheck { get; set; }

        [Setting, DefaultValue("... never")]
        public string Trinket1 { get; set; }

        [Setting, DefaultValue("... never")]
        public string Trinket2 { get; set; }

        [Setting, DefaultValue(45)]
        public int HealthPotionHealth { get; set; }


        #region Beast
        
        [Setting, DefaultValue("... automatic")]
        public string BeastPull { get; set; }


        #endregion


        #region Marks

        [Setting, DefaultValue("... automatic")]
        public string MarksPull { get; set; }


        #endregion


        #region Survival
        [Setting, DefaultValue("... automatic")]
        public string SurvivalPull { get; set; }

        #endregion

    }
}
