﻿using System.Collections.Generic;
using System.Linq;
using System.Text;
using FarmerJoe.Helpers;
using FarmerJoe.Settings;
using Styx.TreeSharp;
using Action = System.Action;

namespace FarmerJoe.Classes
{
    public static partial class Hunter
    {

        public static Composite CombatBehavior_Survival
        {
            get
            {
                return new PrioritySelector(

                    Spells.WaitForCast(),
                    Misc.EnsureTarget(),

                    // Healing
                    Common.UseHealthManaRegenAgent(ClassParser.HealthPotion, 0),

                    Inventory.UseTrinket1(),
                    Inventory.UseTrinket2(),

                    Movement.MoveToLOS(),
                    Movement.FaceTarget(),
                    Movement.Fixes(),




                    new Decorator(ret => Me.IsCasting || Me.IsChanneling, new Styx.TreeSharp.Action(context => RunStatus.Success)),

                    Movement.MoveToTarget(true, 36f)
                    );
            }
        }

        public static Composite PullBehavior_Survival
        {
            get
            {
                return new PrioritySelector(

                    Spells.WaitForCast(),
                    Misc.EnsureTarget(),
                    Movement.MoveToLOS(),
                    Movement.FaceTarget(),
                    new Sequence(ret => Me.Mounted, new Styx.TreeSharp.Action(ret => Spells.Dismount("Pulling")), new Styx.TreeSharp.Action(ctx => RunStatus.Failure)),

                    Movement.Fixes(),

                    new Decorator(ret => FpswareSettings.Instance.Hunter.SurvivalPull.Contains("user defined"),
                                  new PrioritySelector(
                                      )),


                    new Decorator(ret => FpswareSettings.Instance.Hunter.SurvivalPull.Contains("automatic"),
                                  new PrioritySelector(
                                      )),


                    new Decorator(ret => Me.IsCasting || Me.IsChanneling, new Styx.TreeSharp.Action(context => RunStatus.Success)),
                    Movement.MoveToTarget(true, 35f)
                    );
            }
        }

    }
}
